#include "ExpenseHelper.h"
#include <qmessagebox.h>

ExpenseHelper::ExpenseHelper( const ExchangeRates* rates, QWidget *parent)
: QDialog(parent),
  mModel( rates )
{
    // call the generated code from Qt Designer
	setupUi(this);

    // connect the view to the model
    expensesView->setModel( &mModel );
    expensesView->setRootIndex( QModelIndex() );
}

ExpenseHelper::~ExpenseHelper()
{
}

void ExpenseHelper::on_addRowButton_clicked()
{
  mModel.insertRows( mModel.rowCount( QModelIndex() ), 1, QModelIndex() );
}

void ExpenseHelper::on_removeRowButton_clicked()
{
  mModel.removeRows( expensesView->currentIndex().row(), 1, QModelIndex() );
}

void ExpenseHelper::slotRatesParsed()
{
    statusLabel->setText( tr( "Exchange rates are now parsed and available for use." ) );
}
